#include "NandGate.h"
#include <iostream>

int NandGate::nextId=0;
float NandGate::delay=2.0;

NandGate::NandGate (float delay, Simulator* ps)
                :Gate(delay, nextId++, ps) {
}
NandGate::NandGate (Simulator* ps)
                :Gate(NandGate::delay, nextId++, ps) {
}
void NandGate::connectInput(OutSignal * p_output){
	sources.push_back(p_output);
  p_output->addDrain(this);;
  inputValueChanged();
}
bool NandGate::computeOutput(){
	bool result=true;
  for (int i=0; i<sources.size(); i++){
     result = result && sources[i]->getValue(); 
	}  
	return !result;
}
void NandGate::addSource(OutSignal* p_output){
  sources.push_back(p_output);
  inputValueChanged();
}
