#ifndef OR_GATE
#define OR_GATE
#include "Gate.h"
#include "Simulator.h"
#include "OutSignal.h"
using namespace std;

class OrGate: public Gate {
public:
  OrGate (float delay, Simulator * ps);
  OrGate (Simulator * ps);
  virtual void connectInput(OutSignal* p_output);
  virtual bool computeOutput();
  virtual void addSource(OutSignal * p_output);
protected:
  virtual string getSimpleName() const {
     return "OrGate";
  }
private:
  vector<OutSignal*> sources;
  static int nextId;
  static float delay;
};
#endif
