#ifndef SOURCE
#define SOURCE
#include "Gate.h"
#include "OutSignal.h"
#include "UpdateListener.h"
#include "InSignal.h"
#include <fstream>
#include <string>
#include <sstream>
using namespace std;

class Source:public OutSignal, public UpdateListener {
private:
  bool output;
  Simulator* p_sim;
  ifstream data;
  vector<InSignal*> drains;
  static int nextId;
  const int id;

public:
  Source(char * inFiname, Simulator * ps);
  ~Source();
  virtual void updateOutputValue(bool val);
  virtual void propagateOutputValue();
  virtual bool getValue()const {
    return output;
  }
  virtual void connectOutput(InSignal * p_drain);
  virtual void addDrain(InSignal* p_drain);
  virtual string getDescription() const;
};
#endif